# frozen_string_literal: true

# Generated via
#  `rails generate hyrax:work_resource Dataset`
class Dataset < Hyrax::Work
  attribute :complex_person , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  attribute :complex_funding_reference , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  attribute :complex_relation , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  attribute :complex_date , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  attribute :complex_identifier , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  include Hyrax::Schema(:basic_metadata)
  include Hyrax::Schema(:dataset)
  include CommonWorksQuery
  include ::Hyrax::TombstoneBehavior
  include ExternalServices

  def default_admin_set
    AdminSetHelper.find_admin_set_by_property(title: [ENV.fetch('RUB_ADMIN_SET_TITLE', 'RUB publication workflow')])
  end

  def self.find_by_property(**args)
    query = <<-SQL
      SELECT * FROM orm_resources
      WHERE metadata @> ?
      AND internal_resource = 'Dataset';
    SQL

    jsonb_query = args.to_json
    Hyrax.query_service.run_query(query, jsonb_query).first
  end

  def file_sets
    @file_sets ||= Hyrax.custom_queries.find_child_file_sets(resource: self)
  end
end



  